#include <strings.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef unsigned int ui;

//    (   (handler))
struct array_t {
	int N;		// how many pointers are in uses?
				// how many pointers are initialized?

	ui Nmax;		// how many pointers are created?
				// for how many pointers is allocated?

	void **data;	// in C name of an array is a pointer
};

typedef struct array_t array;

// ,     
struct for_type_t {
	ui some_num;
};

typedef struct for_type_t some_type;

//    void
#define VPSZ sizeof(void*)
//   
#define ARSZ sizeof(array)

#define VP (void*)

//   ( ) +    Nmax 
array* arCreat(ui Nmax)
{
 array *res;
 ui count=!Nmax?4:Nmax;

 res = calloc(1, ARSZ); //      

 if (!res) {
    perror(" Can't allocate memory for array handler - \n");
    return NULL;
 };

 res->data=calloc(count, VPSZ); //      
// printf("arr->data - %x\n", res->data);
 if (!res->data) {
    perror(" Can't allocate memory for array of pointers - \n");
    free(res);
    return NULL;
 };
 res->Nmax=count;
 res->N=0;

 return res;
}

//     count 
array* arAdd (array *arr, ui count)
{
 ui mega_count=arr->Nmax+count;
 void *ret;

 ret = realloc(arr->data, mega_count*VPSZ);
 if (!ret) {
    perror(" Can't reallocate memory for expansion of an array - \n");
    return NULL;
 };

 arr->Nmax=mega_count;

 return arr;
}

//   which.
//   (do_free!=0)  
//    arr->data[which]
array* arrDel (array *arr, ui which, char do_free)
{
 void *to = arr->data+VPSZ*which;
 void *from = to+VPSZ;
 ui how_much = VPSZ*(arr->Nmax-which-1);
 void *ret;

 //   
 if (which > arr->Nmax-1) {
    fprintf(stderr, " Can't remove elements beyond the array.\n");
    return NULL;
 };

 if (do_free) free(arr->data[which]); //      arr->data[which]

 // if `which` ain't the last element
 if (which < arr->Nmax-1) memmove(to, from, how_much);

 arr->Nmax--;
 ret=realloc(arr, VPSZ*arr->Nmax); //    (!!) 

 if (!ret) fprintf(stderr, " Can't reallocate memory. Sorry.\n");

 return ret;
}

//   (  )   which
void* retrieveNth (array *arr, ui which)
{
 void *ret;
 if (which>arr->N) {
    fprintf(stderr, " Can't retrieve data from beyond the array\n");
 };

 ret = arr->data[which];

 return ret;
}

//    with_what      which
void* replaceNth (array *arr, ui which, void *with_what)
{
 void *ret;
// printf("\n");
 some_type **data;
 printf("\n arr - %x\n", arr->data);
// some_type **data = (some_type*)arr->data;
 if (which>arr->Nmax-1) {
    fprintf(stderr, " Can't modify data from beyond the array.\n");
    return NULL;
 };


 if (which > arr->N) {
    fprintf(stderr, " This index cannot be used. idx>Nused.\n");
 };

 if (which == arr->N) arr->N++;

 data=(some_type**)(arr->data+which*sizeof(some_type));

// printf("\n - which - %u\n - arr - %x\n - with_what - %x\n", which, arr, with_what);
// printf("\n data[which] - %x\n", data+sizeof(some_type));
// (arr->data+which*sizeof(some_type))=with_what;
// *data=((some_type*)with_what);
 printf("\ndata - %x\n", arr->data);
// data[0]=with_what;
// data[which]=with_what;
// ret = (void*)data;

 return ret;
}

//   
void* creatNew (array *arr, ui size)
{
 void *ret;
 if (arr->N >= arr->Nmax) return NULL;

 ret=calloc(1, size);
 if (!ret) {
    perror(" failed to allocate memory - \n");
    return NULL;
 }

 arr->data[arr->N-1] = ret;
 arr->N++;

 return ret;
}

//  ,   
//    w1  w2, ,      some_type
char dataComp (array *arr, ui w1, ui w2)
{
 char ret=0;
 some_type *p1, *p2;
 p1=(some_type*)arr->data[w1];
 p2=(some_type*)arr->data[w2];

 if ( p1->some_num > p2->some_num ) ret = 1;
 else if (p1->some_num < p2->some_num) ret = -1;

 return ret;
}

//       data (   some_type)
// size -  
ui retriveIdxbyData (array *arr, void *data, ui size)
{
 ui Idx=-1;
 ui atr=0;
 for (Idx=0; Idx<arr->N; Idx++)
     if ( !bcmp(arr->data[Idx], data, size) ) {
        atr = 1;
        break;
     };

 return atr*Idx;
}

//     some_type. .
void sortArr (array* arr)
{
 ui i, j;
 char atr;
 void *buf;

 for (i=0; i<arr->N-1; i++)
     for (j=i+1; j<arr->N; j++) {
         atr=dataComp(arr, i, j);
         if (atr==1) {
            buf=arr->data[i];
            arr->data[i] = arr->data[j];
            arr->data[j] = buf;
         };
     };
}

//  .     , 
void destroyArr (array *arr)
{
 ui i;
 for (i=0; i<arr->N; i++) free(arr->data[i]);
 free(arr->data);
 free(arr);
}

ui retrieveN (array *arr)
{
 return arr->N;
}

int main (void)
{
 array *arr, *ret;
 some_type *st;
 ui i;

 arr = arCreat(0); //     4 
 if (!arr) {
    fprintf(stderr, "arCreat failed.\n");
    return -1;
 }
 printf(" - arr - %x\n", arr);
 ret = arAdd(arr, 2); //   6
 if (!ret) {
    fprintf(stderr, "arAdd failed.\n");
    destroyArr(arr);
    return -1;
 }

 ret = arrDel(arr, 4, 0); //   5
 if (!ret) {
    fprintf(stderr, "arrDel failed.\n");
    destroyArr(arr);
    return -1;
 }

 for (i=0; i<4; i++) {
     printf(" @ %u - ", i);
 printf("\n\n UNO -\n arr->data= %x\n\n", &(arr->data));
     st=calloc(1, sizeof(some_type));
 printf("\n\n BISO -\n st= %x\n\n", st);
     printf(" st - %x, ", st);
     st->some_num = 4-i;
     printf(" some_num - %u,", st->some_num);
     if (!st) {
        fprintf(stderr, " some_type calloc failed @ idx=%u\n", i);
        destroyArr(arr);
        return -1;
     };
     ret=replaceNth(arr, i, VP st);
     printf(" ret - %x, arr - %x\n", ret, arr);
     if (!ret) {
        fprintf(stderr, " failed to replaceNth @ idx=%u", i);
        destroyArr(arr);
        return -1;
     };
 };

 st=(some_type*)creatNew(arr, sizeof(some_type));
 if (!st) {
    fprintf(stderr, " failed to creatNew ");
    destroyArr(arr);
    return -1;
 };
 st->some_num=5;

 sortArr(arr);

 for (i=0; i<5; i++) {
     st=(some_type*)retrieveNth(arr, i);
     if (!st) {
        fprintf(stderr, " failed to retriveNth @ idx=%u ", i);
        destroyArr(arr);
        return -1;
     };
     printf("%u ", st->some_num);
 };

 destroyArr(arr);

 return 0;
}
